/************************************************************************/
/*									*/
/*			AD Conversion Example				*/
/*									*/
/*		Author: P. Dannegger					*/
/*			danni@specs.de					*/
/*									*/
/************************************************************************/
#include<signal.h>
#include<interrupt.h>
#include<io.h>

typedef unsigned char  u8;
typedef   signed char  s8;
typedef unsigned short u16;
typedef   signed short s16;
typedef unsigned long  u32;
typedef   signed long  s32;


#define	xtal	1000000L		// 1MHz


#define	pin_d0	PB4
#define	pin_d1	PB3
#define	pin_d2	PB1
#define	pin_d3	PB0

#define	unused0	PB2				//unused portpins
#define	unused1 PB6

#define	_0A	0x02				//segment order
#define	_0B	0x04
#define	_0C	0x40
#define	_0D	0x10
#define	_0E	0x08
#define	_0F	0x01
#define	_0G	0x20
#define	_0DP	0x80				//decimal point

#define	_00	(u8)~( _0A+_0B+_0C+_0D+_0E+_0F     )	//number pattern, low active
#define	_01	(u8)~(     _0B+_0C                 )
#define	_02	(u8)~( _0A+_0B+    _0D+_0E+    _0G )
#define	_03	(u8)~( _0A+_0B+_0C+_0D+        _0G )
#define	_04	(u8)~(     _0B+_0C+        _0F+_0G )
#define	_05	(u8)~( _0A+    _0C+_0D+    _0F+_0G )
#define	_06	(u8)~( _0A+    _0C+_0D+_0E+_0F+_0G )
#define	_07	(u8)~( _0A+_0B+_0C                 )
#define	_08	(u8)~( _0A+_0B+_0C+_0D+_0E+_0F+_0G )
#define	_09	(u8)~( _0A+_0B+_0C+_0D    +_0F+_0G )

#define	_1A	0x40				//segment order
#define	_1B	0x80
#define	_1C	0x04
#define	_1D	0x02
#define	_1E	0x01
#define	_1F	0x10
#define	_1G	0x20
#define	_1DP	0x08				//decimal point

#define	_10	(u8)~( _1A+_1B+_1C+_1D+_1E+_1F     )	//number pattern, low active
#define	_11	(u8)~(     _1B+_1C                 )
#define	_12	(u8)~( _1A+_1B+    _1D+_1E+    _1G )
#define	_13	(u8)~( _1A+_1B+_1C+_1D+        _1G )
#define	_14	(u8)~(     _1B+_1C+        _1F+_1G )
#define	_15	(u8)~( _1A+    _1C+_1D+    _1F+_1G )
#define	_16	(u8)~( _1A+    _1C+_1D+_1E+_1F+_1G )
#define	_17	(u8)~( _1A+_1B+_1C                 )
#define	_18	(u8)~( _1A+_1B+_1C+_1D+_1E+_1F+_1G )
#define	_19	(u8)~( _1A+_1B+_1C+_1D    +_1F+_1G )


u8 digit[4];
u16 adc_val;

u8 numbers0[] = { _00, _01, _02, _03, _04, _05, _06, _07, _08, _09 };

u8 numbers1[] = { _10, _11, _12, _13, _14, _15, _16, _17, _18, _19 };
